#!/usr/bin/perl
$|=1;
############################################################################
#                                                                          #
# Application  : arform.cgi                                                #
# Description  : Argala Form Script                                        #
# Version      : 1.00                                                      #
# Created      : 7th April 2000                                            #
# Last Updated : 17th May 2000                                             #
#                                                                          #
# Copyright (c) 2000 Argala.com All rights reserved.                       #
# WWW    : http://www.argala.com                                           #
# Email  : webmaster@argala.com                                            #
#                                                                          #
############################################################################

require "cgi-lib.pl";
require "arform.cfg";
require "config.pl";

if (-e "custom.pl") {
  require "custom.pl";   
}

$message_log   = "$arformdata_path/message_log";

$html_template = "$arformdata_path/form.htmt";

$script_url = $ENV{'SCRIPT_NAME'};

&ReadParse(*FORM);

if ($FORM{'submit'} ne ""){

   if ($FORM{'name'} ne "" && $FORM{'email'} ne "" && $FORM{'message'} ne ""){    
   
      &get_file_lock("arform.lockfile");
      &write_log;
      &release_file_lock("arform.lockfile");
      
      
      $send_email_text = $FORM{'message'} ;
      $send_email_text =~ s/~p~/|/gi;
      $send_email_text =~ s/~nl~/\n/gi;

      $email_text = $send_email_text;                         
      
      $send_email_text = $send_email_header_text . "\n\n" . $send_email_text . "\n\n" .
                         $send_email_footer_text;
            
      $email_text = "You have the following message from $FORM{'name'} : \n" .
                    "The email address is $FORM{'email'}. \n".
                    "The message is \n". $email_text ;                    
       
      &send_mail($FORM{'email'}, $admin_mail, "$mail_subject", $email_text);
      
      if ($send_mail_user) {      
         &send_mail($admin_mail, $FORM{'email'}, "$mail_subject", $send_email_text);
      }   

      &thank_you;
   } 
   else {
      if($FORM{'name'} eq ""){
         $required_name     = 1;
      }
      if($FORM{'email'} eq ""){
         $required_email    = 1;
      }
      if($FORM{'message'} eq ""){
         $required_message  = 1;
      }
      &message_form;             
   }
}
else{
    &message_form;
}

# read template

open(SUPPORTHTML,"$html_template") || die("can't open $html_template");
@support_html = <SUPPORTHTML>;
close(SUPPORTHTML);

print "Content-type: text/html\n\n"; 

foreach $line(@support_html){
   $line =~ s/#SUPPORT#/$html/gi;
   print "$line\n";
}

exit;  

###### functions ##########

sub message_form{

if($required_name){
  $required_name_text = "<font face=\"$arform_fontface\" color=#ff0000>($required_text)</font>";
}
else{
  $required_name_text = "";
}
if($required_email){
  $required_email_text = "<font face=\"$arform_fontface\" color=#ff0000>($required_text)</font>";
}
else{
  $required_email_text = "";
}

if($required_message){
  $required_message_text = "<font face=\"$arform_fontface\" color=#ff0000>($required_text)</font>";
}
else{
  $required_message_text = "";
}

$message = $FORM{'message'};

$message =~ s/~p~/|/gi;
$message =~ s/~nl~/\n/gi;

$html = 
qq~
<center>

<font face="$arform_fontface" size="$arform_fontsize">$message_text</font>
<br>
<form method="post" action="$script_url">
~;

$html .=
qq~
<table border=0>
<tr>
<td align=left><font face="$arform_fontface" size="$arform_fontsize">$name_text</font></td>
<td width=4 align=left>:</td>
<td align=left><input type="text" size=30 name="name" value=$FORM{'name'}> <font face="$arform_fontface" size="$arform_fontsize">$required_name_text</font></td>
</tr>
<tr>
<td align=left><font face="$arform_fontface" size="$arform_fontsize">$email_text</font></td>
<td width=4 align=left>:</td>
<td align=left><input type="text" size=30 name="email" value=$FORM{'email'}> <font face="$arform_fontface" size="$arform_fontsize">$required_email_text</font></td>
</tr>
<tr>
<td align=left colspan=3><font face="$arform_fontface" size="$arform_fontsize">$question_text $required_message_text</font></td>
</tr>
<tr>
<td align=left colspan=3><font face="$arform_fontface" size="$arform_fontsize"><textarea rows=6 cols=40 name="message">$message</textarea></font></td>
</tr>
<tr>
<td colspan=3 align=center><br><input type=submit value="$submit_text" name="submit">\&nbsp<input type=reset value="$reset_text"></td> 
</tr>
</table>
</form>
</center>
~;
}

sub write_log {
   
   local($message, $date);
   
   $date = &get_date;
   
   $message = "$date|$FORM{'name'}|$FORM{'email'}|$FORM{'message'}";
      
   open(MESSAGE, ">>$message_log") || die ("can't open $message_log");      
   print MESSAGE "$message\n";   
   close(MESSAGE);    
}

sub thank_you{
      
   $html =
   qq~ 
   <center> 
   <font size=+1 face="$arform_fontface">
   $thankyou_text
   </font>
   </center>
   ~;

}

sub real_send_mail {
    local($fromuser, $fromsmtp, $touser, $tosmtp, 
      $subject, $messagebody) = @_;

    open (MAIL, "|$mailprog -t") ;
    print MAIL <<__END_OF_MAIL__;
To: $touser
From: $fromuser
Subject: $subject

$messagebody

__END_OF_MAIL__

    close (MAIL);

} 

sub send_mail {

    local($from, $to, $subject, $messagebody) = @_;

    local($fromuser, $fromsmtp, $touser, $tosmtp);

    $fromuser = $from;
    $touser   = $to;

    $fromsmtp = (split(/\@/,$from))[1];
    $tosmtp = (split(/\@/,$to))[1];

    &real_send_mail($fromuser, $fromsmtp, $touser, 
           $tosmtp, $subject, $messagebody);

}

sub get_date {

  local ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst,$date);
  local (@days, @months);
 
  @days   = ('Sunday','Monday','Tuesday','Wednesday','Thursday',
             'Friday','Saturday');
  @months = ('January','February','March','April','May','June','July',
             'August','September','October','November','December');

  ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);

  if ($hour < 10) { 
    $hour = "0$hour"; 
  }
  if ($min < 10) { 
    $min = "0$min"; 
  }
  if ($sec < 10) {
    $sec = "0$sec";
  }
  
  $year = 1900 + $year;

  $date = "$days[$wday], $months[$mon] $mday, $year at $hour\:$min\:$sec";
  return $date;

}

sub get_file_lock {

  local ($lock_file) = @_;
  local ($endtime);
  $endtime = 50;
  $endtime = time + $endtime;

  while (-e $lock_file && time < $endtime){
    sleep(1);
  }

  open(LOCK_FILE, ">$lock_file") || &CgiDie ("Could not open the lock file");
  if($flock) {
     flock(LOCK_FILE, 2);
  }
  
} 

sub release_file_lock{
  local ($lock_file) = @_;
  if($flock) {
     flock(LOCK_FILE, 8);
  }
  close(LOCK_FILE);
  unlink($lock_file);
} 

